Package org.eclipse.emf.cdo.transaction

# Interface CDOSavepoint

All Superinterfaces:
  `CDOChangeSetDataProvider`, `CDORollbackable`, `CDOTransactionAware`, `CDOUserSavepoint`

All Known Subinterfaces:
  `InternalCDOSavepoint`

public interface CDOSavepoint extends CDOUserSavepoint, CDOTransactionAware, CDOChangeSetDataProvider
One in a sequence of possibly several points in time of a `transaction` that encapsulates the changes to transactional objects and that later changes can be `rolled back` to.

Author:
  Eike Stepper
No Implement
  This interface is not intended to be implemented by clients.
No Extend
  This interface is not intended to be extended by clients.

## Method Summary

Modifier and Type
Method
Description
`Map<CDOID,CDORevision>`
`getAllBaseNewObjects()`
Returns the aggregate of base revisions at this savepoint's fixed boundary.
`CDOChangeSetData`
`getAllChangeSetData()`
Returns the change-set data at this savepoint's fixed boundary.
`Map<CDOID,CDOObject>`
`getAllDetachedObjects()`
Returns the aggregate of detached objects at this savepoint's fixed boundary.
`Map<CDOID,CDOObject>`
`getAllDirtyObjects()`
Returns the aggregate of dirty objects at this savepoint's fixed boundary.
`Map<CDOID,CDOObject>`
`getAllNewObjects()`
Returns the aggregate of new objects at this savepoint's fixed boundary, excluding objects that were removed before that boundary.
`Map<CDOID,CDORevisionDelta>`
`getAllRevisionDeltas()`
Returns the aggregate of revision deltas at this savepoint's fixed boundary, excluding objects that were removed before that boundary.
`Map<CDOID,CDORevision>`
`getBaseNewObjects()`
Returns objects that were already new at this savepoint's boundary.
`Map<CDOID,CDOObject>`
`getDetachedObjects()`
Returns objects detached at this savepoint.
`Map<CDOID,CDOObject>`
`getDirtyObjects()`
Returns objects modified at this savepoint.
`Map<CDOID,CDOObject>`
`getNewObjects()`
Returns objects created at this savepoint.
`CDOSavepoint`
`getNextSavepoint()`
Returns the next savepoint after this one.
`CDOSavepoint`
`getPreviousSavepoint()`
Returns the savepoint preceding this one.
`Map<CDOID,CDOObject>`
`getReattachedObjects()`
Returns objects reattached at this savepoint.
`ConcurrentMap<CDOID,CDORevisionDelta>`
`getRevisionDeltas()`
Deprecated.
As of 4.2 use `getRevisionDeltas2()` instead.
`Map<CDOID,CDORevisionDelta>`
`getRevisionDeltas2()`
Returns deltas of the revisions modified at this savepoint.
`CDOTransaction`
`getTransaction()`
Returns the transaction that owns this savepoint.
`boolean`
`wasDirty()`
Indicates whether the transaction was dirty when this savepoint was created.

### Methods inherited from interface org.eclipse.emf.cdo.common.commit.CDOChangeSetDataProvider

`getChangeSetData`

### Methods inherited from interface org.eclipse.emf.cdo.transaction.CDOUserSavepoint

`getNumber, isLast, isValid, rollback`

## Method Details

### getTransaction

CDOTransaction getTransaction()
Returns the transaction that owns this savepoint.

Specified by:
  `getTransaction` in interface `CDOTransactionAware`
Specified by:
  `getTransaction` in interface `CDOUserSavepoint`
Returns:
  the owning transaction.
Since:
  3.0

### getNextSavepoint

CDOSavepoint getNextSavepoint()
Returns the next savepoint after this one.

Specified by:
  `getNextSavepoint` in interface `CDOUserSavepoint`
Returns:
  the next savepoint, or `null`.

### getPreviousSavepoint

CDOSavepoint getPreviousSavepoint()
Returns the savepoint preceding this one.

Specified by:
  `getPreviousSavepoint` in interface `CDOUserSavepoint`
Returns:
  the previous savepoint, or `null`.

### wasDirty

boolean wasDirty()
Indicates whether the transaction was dirty when this savepoint was created.

Returns:
  `true` if the transaction was dirty.
Since:
  3.0

### getBaseNewObjects

Map<CDOID,CDORevision> getBaseNewObjects()
Returns objects that were already new at this savepoint's boundary.

Returns:
  the base-new object map.
Since:
  3.0

### getNewObjects

Map<CDOID,CDOObject> getNewObjects()
Returns objects created at this savepoint.

Returns:
  the new-object map.
Since:
  3.0

### getDetachedObjects

Map<CDOID,CDOObject> getDetachedObjects()
Returns objects detached at this savepoint.

Returns:
  the detached-object map.
Since:
  3.0

### getReattachedObjects

Map<CDOID,CDOObject> getReattachedObjects()
Returns objects reattached at this savepoint. Bug 283985 (Re-attachment)

Returns:
  the reattached-object map.
Since:
  3.0

### getDirtyObjects

Map<CDOID,CDOObject> getDirtyObjects()
Returns objects modified at this savepoint.

Returns:
  the dirty-object map.
Since:
  3.0

### getRevisionDeltas2

Map<CDOID,CDORevisionDelta> getRevisionDeltas2()
Returns deltas of the revisions modified at this savepoint.

Since:
  4.2

### getAllBaseNewObjects

Map<CDOID,CDORevision> getAllBaseNewObjects()
Returns the aggregate of base revisions at this savepoint's fixed boundary. Changes recorded in the mutable segment that follows this savepoint are not included.

Since:
  3.0

### getAllNewObjects

Map<CDOID,CDOObject> getAllNewObjects()
Returns the aggregate of new objects at this savepoint's fixed boundary, excluding objects that were removed before that boundary. Changes recorded in the mutable segment that follows this savepoint are not included.

Since:
  3.0

### getAllDetachedObjects

Map<CDOID,CDOObject> getAllDetachedObjects()
Returns the aggregate of detached objects at this savepoint's fixed boundary. Changes recorded in the mutable segment that follows this savepoint are not included.

Since:
  3.0

### getAllDirtyObjects

Map<CDOID,CDOObject> getAllDirtyObjects()
Returns the aggregate of dirty objects at this savepoint's fixed boundary. Changes recorded in the mutable segment that follows this savepoint are not included.

Since:
  3.0

### getAllRevisionDeltas

Map<CDOID,CDORevisionDelta> getAllRevisionDeltas()
Returns the aggregate of revision deltas at this savepoint's fixed boundary, excluding objects that were removed before that boundary. Changes recorded in the mutable segment that follows this savepoint are not included.

Since:
  3.0

### getAllChangeSetData

CDOChangeSetData getAllChangeSetData()
Returns the change-set data at this savepoint's fixed boundary. Changes recorded in the mutable segment that follows this savepoint are not included.

Since:
  4.0

### getRevisionDeltas

@Deprecated ConcurrentMap<CDOID,CDORevisionDelta> getRevisionDeltas()
Deprecated.
As of 4.2 use `getRevisionDeltas2()` instead.
The returned map delegates to `getRevisionDeltas2()` and does not support the following methods:

- `ConcurrentMap.putIfAbsent(Object, Object)`
- `ConcurrentMap.remove(Object, Object)`
- `ConcurrentMap.replace(Object, Object)`
- `ConcurrentMap.replace(Object, Object, Object)`

Since:
  3.0